@ECHO OFF
REM TODO-LISTE
REM ------------
REM - CLEANUP (DAT & UNPACK & LOG)
REM - Optimales Mapping fr Attributo? : Abstimmung im Forum
REM - Riva (ASF Dateien konvertieren > wie??)
REM - Austausch weiterer Sounds?
REM --> Zauber erfolgreich/fehlgeschlagen (Sound Files in SchickRE nicht gefunden)
REM --> Kampfsounds (Sound Files in SchickRE nicht gefunden)
REM --> weitere Sounds?
REM - Austausch von 2D Ansichten (noch nicht geprueft / noch nicht moeglich)


SETLOCAL ENABLEDELAYEDEXPANSION
set MODPATH=%~dp0
set SCRIPT_NAME=%~n0
set MAPPING_FILE_NLT2=%MODPATH%\supportdata\mappingfiles\ntl2.csv
set NLT2_SOUND_DAT_FILE=SPEECH.DAT
REM # Schatten ueber Riva: funktioniert noch nicht
REM set RIVA_SOUND_DAT_FILE=RIVA.ALF
set LOGFILE_TIME=%DATE%_%TIME::=.%
set LOGFILE_TIME=%LOGFILE_TIME:,=.%
set LOGFILE_TIME=%LOGFILE_TIME: =%
set LOGFILE=%MODPATH%\supportdata\log\%SCRIPT_NAME%_%LOGFILE_TIME%.log
goto CREATE_LOGFILE


:CREATE_LOGFILE
echo. >%LOGFILE%
goto SHOW_CREDITS


:SHOW_CREDITS
call :WRITE_LOG ""
call :WRITE_LOG "C R E D I T S"
call :WRITE_LOG "-------------------------------------"
call :WRITE_LOG ""
call :WRITE_LOG "Author: Gerion"
call :WRITE_LOG ""
call :WRITE_LOG "Das Paket enthaelt und verwendet folgende Drittanbieter-Software:"
call :WRITE_LOG "- nltpack (mit freundlicher Genehmigung des Autors [Hendrik Radke]): https://github.com/Henne/BrightEyes/tree/master/tools/nltpack"
call :WRITE_LOG "- SoX (GPL): http://sox.sourceforge.net/"
call :WRITE_LOG "- MinGW (GPL): http://www.mingw.org/"
call :WRITE_LOG ""
call :WRITE_LOG "-------------------------------------"
call :WRITE_LOG ""
call :WRITE_LOG "DIESES SKRIPT ERSETZT DIE SOUNDS DER ZAUBERSPRUECHE IN STERNENSCHWEIF HD DURCH DIE DER ALTEN DOS-VERSION"
call :WRITE_LOG "Aus urheberrechtlichen Gruenden sind die DOS-Sound-Dateien selbst nicht Bestandteil des Paketes."
call :WRITE_LOG "Es wird das DOS-Originalspiel 'Sternenschweif' benoetigt (CD-Version oder Download-Version)."
call :WRITE_LOG ""
pause


:CHECK_MOD_DIR
echo %MODPATH% |findstr "%USERPROFILE%\Documents\StarTrail\usermods" >NUL
if errorlevel 1 (
	call :WRITE_LOG ""
	call :WRITE_LOG "WARNUNG: Die MOD scheint sich nicht im offiziellen-MOD-Verzeichnis von Sternenschweif-HD zu befinden!"
	call :WRITE_LOG ""	
	call :ASK_FOR_CONTINUE
)


:ASK_FOR_ELF_SOUNDS
set ASK_FOR_ELF_SOUNDS_ANSWER=
call :WRITE_LOG ""
call :WRITE_LOG ""
call :WRITE_LOG "WOLLEN SIE AUCH DIE ZAUBERSOUNDS DER ELFISCHEN ZAUBER-VERTONUNG ERSETZEN? (j/n)"
call :WRITE_LOG ""

set /P ASK_FOR_ELF_SOUNDS_ANSWER=
call :WRITE_LOG "Eingabe: %ASK_FOR_ELF_SOUNDS_ANSWER%"

if /i "%ASK_FOR_ELF_SOUNDS_ANSWER%" == "j" (
	set ELF_SOUND_REPLACE_FLAG=1
	goto CHECK_IF_STEAM_INSTALLED
) else if /i "%ASK_FOR_ELF_SOUNDS_ANSWER%" == "ja" (
	set ELF_SOUND_REPLACE_FLAG=1
	goto CHECK_IF_STEAM_INSTALLED
) else if /i "%ASK_FOR_ELF_SOUNDS_ANSWER%" == "n" (
	goto CHECK_IF_STEAM_INSTALLED
) else if /i "%ASK_FOR_ELF_SOUNDS_ANSWER%" == "nein" (
	goto CHECK_IF_STEAM_INSTALLED
) else (
	call :WRITE_LOG "FEHLERHAFTE EINGABE."
	call :WRITE_LOG "Bitte verwenden Sie J oder N"
	goto ASK_FOR_ELF_SOUNDS
)


:CHECK_IF_STEAM_INSTALLED
call :WRITE_LOG "Pruefe ob Steam installiert ist..."
REG QUERY "HKEY_LOCAL_MACHINE\SOFTWARE\Valve\Steam" /v InstallPath >NUL 2>&1 || REG QUERY "HKEY_LOCAL_MACHINE\SOFTWARE\Wow6432Node\Valve\Steam" /v InstallPath >NUL 2>&1
if errorlevel 1 (
	call :WRITE_LOG "Steam nicht gefunden."
	set STEAM_INSTALLED_FLAG=0
) else (
	call :WRITE_LOG "Steam gefunden."
	set STEAM_INSTALLED_FLAG=1
	
	call :WRITE_LOG "Ermittle Steam-Install-Pfad..."
	for /f "tokens=3* delims= " %%a in ('REG QUERY "HKEY_LOCAL_MACHINE\SOFTWARE\Valve\Steam" /v InstallPath ^|findstr /b /v HKEY_LOCAL_MACHINE ^& REG QUERY "HKEY_LOCAL_MACHINE\SOFTWARE\Wow6432Node\Valve\Steam" /v InstallPath ^|findstr /b /v HKEY_LOCAL_MACHINE') do (
		if exist "%%a\Steam.exe" (
			set STEAMPATH=%%a
		)

		if exist "%%a %%b\Steam.exe" (
			set STEAMPATH=%%a %%b
		)

		if exist "%%a %%b %%c\Steam.exe" (
			set STEAMPATH=%%a %%b %%c
		)

		if exist "%%a %%b %%c %%d\Steam.exe" (
			set STEAMPATH=%%a %%b %%c %%d
		)	
		
		if "!STEAMPATH!" == "" (
			call :WRITE_LOG "...Steam-Pfad konnte nicht identifiziert werden!"
			call :WRITE_LOG "Pfad fuer Steam konnte nicht gefunden werden."

			call :WRITE_LOG ""
			call :WRITE_LOG ""
			call :WRITE_LOG "Bitte Pfad fuer Steam eingeben:"
			call :WRITE_LOG "z.B.: C:\Program Files\Steam"
			set /P STEAMPATH=
			call :WRITE_LOG "Eingabe: %STEAMPATH%"
			
			if not exist "!STEAMPATH!" (
				call :WRITE_LOG "FEHLER: Verzeichnis konnte nicht gefunden werden."
				goto CHECK_IF_STEAM_INSTALLED
			) else (
				call :WRITE_LOG "...Steam-Pfad identifiziert: !STEAMPATH!"
			)			
			
		) else (
			call :WRITE_LOG "...Steam-Pfad identifiziert: !STEAMPATH!"
		)
	)
)
goto DAT_FILES_CHECK_STEAM_AND_GOG_PATHS


:DAT_FILES_CHECK_STEAM_AND_GOG_PATHS
if "%STEAM_INSTALLED_FLAG%" == "1" (
	call :WRITE_LOG "Suche Original-Spiel (Steam-Version)..."
	call :WRITE_LOG "Suche Install Pfad (Steam-Version)..."
	for /F "tokens=* USEBACKQ" %%F in (`reg query HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall /e /d /f "Realms of Arkania 2 - Star Trail Classic" /s`) do (
		echo "%%F"|findstr /i "HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall\Steam App" >NUL
		if "!ERRORLEVEL!" == "0" (
			set INSTALL_PATH_ORG_STEAM=%%F
			call :WRITE_LOG "...Install Pfad identifiziert: !INSTALL_PATH_ORG_STEAM!"
			goto FIND_ORG_STEAM_PATH
		)
	)
)

call :WRITE_LOG "Suche Original-Spiel (GOG-Version)..."
call :WRITE_LOG "Suche Install Pfad (GOG-Version)..."
for /F "tokens=* USEBACKQ" %%F in (`reg query HKEY_LOCAL_MACHINE\SOFTWARE\GOG.com /e /d /f "Realms of Arkania 2 - Star Trail" /s ^& reg query HKEY_LOCAL_MACHINE\SOFTWARE\Wow6432Node\GOG.com /e /d /f "Realms of Arkania 2 - Star Trail" /s`) do (
	echo "%%F"|findstr /i "HKEY_LOCAL_MACHINE"|findstr /i GOG.com" >NUL
	if "!ERRORLEVEL!" == "0" (
		set INSTALL_PATH_ORG_GOG=%%F
		call :WRITE_LOG "...Install Pfad identifiziert: !INSTALL_PATH_ORG_GOG!"
		goto FIND_ORG_GOG_PATH
	)
)

call :WRITE_LOG "Original-Spiel:Weder Steam- noch GOG-Version gefunden..."
goto ASK_FOR_DAT_AUTO_DETECT_CD


:FIND_ORG_GOG_PATH
call :WRITE_LOG "Suche GOG-Pfad-Original..."
for /f "tokens=1 delims=:" %%a in ('REG QUERY "%INSTALL_PATH_ORG_GOG%" /v PATH ^|findstr /b /v HKEY_LOCAL_MACHINE') do (
	set STERNORGDRIVETMP=%%a
	set STERNORGDRIVE=!STERNORGDRIVETMP:~-1!:
)

for /f "tokens=2-9 delims=\" %%a in ('REG QUERY "%INSTALL_PATH_ORG_GOG%" /v PATH ^|findstr /b /v HKEY_LOCAL_MACHINE') do (
	if exist "%STERNORGDRIVE%\%%a\STAR.exe" (
		set PATH_ORIGINAL_STERN_DOWNLOAD_EDITION=%STERNORGDRIVE%\%%a
		goto FIND_DAT_FILE_STEAM_AND_GOG
	)
	
	if exist "%STERNORGDRIVE%\%%a\%%b\STAR.exe" (
		set PATH_ORIGINAL_STERN_DOWNLOAD_EDITION=%STERNORGDRIVE%\%%a\%%b
		goto FIND_DAT_FILE_STEAM_AND_GOG
	)

	if exist "%STERNORGDRIVE%\%%a\%%b\%%c\STAR.exe" (
		set PATH_ORIGINAL_STERN_DOWNLOAD_EDITION=%STERNORGDRIVE%\%%a\%%b\%%c
		goto FIND_DAT_FILE_STEAM_AND_GOG
	)

	if exist "%STERNORGDRIVE%\%%a\%%b\%%c\%%d\STAR.exe" (
		set PATH_ORIGINAL_STERN_DOWNLOAD_EDITION=%STERNORGDRIVE%\%%a\%%b\%%c\%%d
		goto FIND_DAT_FILE_STEAM_AND_GOG
	)

	if exist "%STERNORGDRIVE%\%%a\%%b\%%c\%%d\%%e\STAR.exe" (
		set PATH_ORIGINAL_STERN_DOWNLOAD_EDITION=%STERNORGDRIVE%\%%a\%%b\%%c\%%d\%%e
		goto FIND_DAT_FILE_STEAM_AND_GOG
	)

	if exist "%STERNORGDRIVE%\%%a\%%b\%%c\%%d\%%e\%%f\STAR.exe" (
		set PATH_ORIGINAL_STERN_DOWNLOAD_EDITION=%STERNORGDRIVE%\%%a\%%b\%%c\%%d\%%e\%%f
		goto FIND_DAT_FILE_STEAM_AND_GOG
	)


	if exist "%STERNORGDRIVE%\%%a\%%b\%%c\%%d\%%e\%%f\%%g\STAR.exe" (
		set PATH_ORIGINAL_STERN_DOWNLOAD_EDITION=%STERNORGDRIVE%\%%a\%%b\%%c\%%d\%%e\%%f\%%g
		goto FIND_DAT_FILE_STEAM_AND_GOG
	)

	if exist "%STERNORGDRIVE%\%%a\%%b\%%c\%%d\%%e\%%f\%%g\%%h\STAR.exe" (
		set PATH_ORIGINAL_STERN_DOWNLOAD_EDITION=%STERNORGDRIVE%\%%a\%%b\%%c\%%d\%%e\%%f\%%g\%%h
		goto FIND_DAT_FILE_STEAM_AND_GOG
	)
	
	if "!PATH_ORIGINAL_STERN_DOWNLOAD_EDITION!" == "" (
		call :WRITE_LOG "WARNUNG ...GOG-Pfad-Original konnte nicht dynamisch identifiziert werden!"
		call :WRITE_LOG "WARNUNG Versuche statische Identifizierung..."
	)
	
	if exist "C:\GOG Games\Realms of Arkania 2\STAR.exe" (
		set PATH_ORIGINAL_STERN_DOWNLOAD_EDITION=C:\GOG Games\Realms of Arkania 2
	)
	
	if "!PATH_ORIGINAL_STERN_DOWNLOAD_EDITION!" == "" (
		call :WRITE_LOG "...GOG-Pfad-Original konnte nicht identifiziert werden!"
		goto ASK_FOR_DAT_AUTO_DETECT_CD
	) else (
		call :WRITE_LOG "...GOG-Pfad-Original identifiziert: !PATH_ORIGINAL_STERN_DOWNLOAD_EDITION!"
		goto FIND_DAT_FILE_STEAM_AND_GOG
	)
)


:FIND_ORG_STEAM_PATH
call :WRITE_LOG "Suche STEAM-Pfad-Original..."
for /f "tokens=1 delims=:" %%a in ('REG QUERY "%INSTALL_PATH_ORG_STEAM%" /v InstallLocation ^|findstr /b /v HKEY_LOCAL_MACHINE') do (
	set STERNORGDRIVETMP=%%a
	set STERNORGDRIVE=!STERNORGDRIVETMP:~-1!:
)

for /f "tokens=2-9 delims=\" %%a in ('REG QUERY "%INSTALL_PATH_ORG_STEAM%" /v InstallLocation ^|findstr /b /v HKEY_LOCAL_MACHINE') do (
	if exist "%STERNORGDRIVE%\%%a\DSA2.bat" (
		set PATH_ORIGINAL_STERN_DOWNLOAD_EDITION=%STERNORGDRIVE%\%%a
		goto FIND_DAT_FILE_STEAM_AND_GOG
	)
	
	if exist "%STERNORGDRIVE%\%%a\%%b\DSA2.bat" (
		set PATH_ORIGINAL_STERN_DOWNLOAD_EDITION=%STERNORGDRIVE%\%%a\%%b
		goto FIND_DAT_FILE_STEAM_AND_GOG
	)

	if exist "%STERNORGDRIVE%\%%a\%%b\%%c\DSA2.bat" (
		set PATH_ORIGINAL_STERN_DOWNLOAD_EDITION=%STERNORGDRIVE%\%%a\%%b\%%c
		goto FIND_DAT_FILE_STEAM_AND_GOG
	)

	if exist "%STERNORGDRIVE%\%%a\%%b\%%c\%%d\DSA2.bat" (
		set PATH_ORIGINAL_STERN_DOWNLOAD_EDITION=%STERNORGDRIVE%\%%a\%%b\%%c\%%d
		goto FIND_DAT_FILE_STEAM_AND_GOG
	)

	if exist "%STERNORGDRIVE%\%%a\%%b\%%c\%%d\%%e\DSA2.bat" (
		set PATH_ORIGINAL_STERN_DOWNLOAD_EDITION=%STERNORGDRIVE%\%%a\%%b\%%c\%%d\%%e
		goto FIND_DAT_FILE_STEAM_AND_GOG
	)

	if exist "%STERNORGDRIVE%\%%a\%%b\%%c\%%d\%%e\%%f\DSA2.bat" (
		set PATH_ORIGINAL_STERN_DOWNLOAD_EDITION=%STERNORGDRIVE%\%%a\%%b\%%c\%%d\%%e\%%f
		goto FIND_DAT_FILE_STEAM_AND_GOG
	)


	if exist "%STERNORGDRIVE%\%%a\%%b\%%c\%%d\%%e\%%f\%%g\DSA2.bat" (
		set PATH_ORIGINAL_STERN_DOWNLOAD_EDITION=%STERNORGDRIVE%\%%a\%%b\%%c\%%d\%%e\%%f\%%g
		goto FIND_DAT_FILE_STEAM_AND_GOG
	)

	if exist "%STERNORGDRIVE%\%%a\%%b\%%c\%%d\%%e\%%f\%%g\%%h\DSA2.bat" (
		set PATH_ORIGINAL_STERN_DOWNLOAD_EDITION=%STERNORGDRIVE%\%%a\%%b\%%c\%%d\%%e\%%f\%%g\%%h
		goto FIND_DAT_FILE_STEAM_AND_GOG
	)
	
	if "!PATH_ORIGINAL_STERN_DOWNLOAD_EDITION!" == "" (
		call :WRITE_LOG "WARNUNG ...Steam-Pfad-Original konnte nicht dynamisch identifiziert werden!"
		call :WRITE_LOG "WARNUNG Versuche statische Identifizierung..."
	)
	
	if exist "C:\Program Files\Steam\steamapps\common\Realms of Arkania 2 Startrail Classic\DSA2.bat" (
		set PATH_ORIGINAL_STERN_DOWNLOAD_EDITION=C:\Program Files\Steam\steamapps\common\Realms of Arkania 2 Startrail Classic
	)

	if "!PATH_ORIGINAL_STERN_DOWNLOAD_EDITION!" == "" (
		call :WRITE_LOG "...Steam-Pfad-Original konnte nicht identifiziert werden!"
		goto ASK_FOR_DAT_AUTO_DETECT_CD
	) else (
		call :WRITE_LOG "...Steam-Pfad-Original identifiziert: !PATH_ORIGINAL_STERN_DOWNLOAD_EDITION!"
		goto FIND_DAT_FILE_STEAM_AND_GOG
	)
)


:FIND_DAT_FILE_STEAM_AND_GOG
call :WRITE_LOG "Suche DAT-Datei..."
pushd %PATH_ORIGINAL_STERN_DOWNLOAD_EDITION%
for /r %%x in (%NLT2_SOUND_DAT_FILE%) do (
	if exist "%%x" (
		call :WRITE_LOG "...NLT2-DAT-Datei gefunden: %%x."
		call :WRITE_LOG "Kopiere DAT-Datei %%x..."
		xcopy "%%x" "%MODPATH%\supportdata\dat\nlt2\*" /R /Y >>"%LOGFILE%" 2>&1
		if not exist "%MODPATH%\supportdata\dat\nlt2\%NLT2_SOUND_DAT_FILE%" (
			call :WRITE_LOG "FEHLER beim Kopieren der DAT-Datei."
			popd
			goto ERROREXIT
		)
		call :WRITE_LOG "...DAT-Datei kopiert"
		set DAT_FILE=%MODPATH%\supportdata\dat\nlt2\%NLT2_SOUND_DAT_FILE%
		set MAPPING_FILE=%MAPPING_FILE_NLT2%
		set UNPACK_PATH=%MODPATH%\supportdata\unpack\nlt2
		popd
		goto UNPACK_NLT2
	)
)


:ASK_FOR_DAT_AUTO_DETECT_CD
call :WRITE_LOG ""
call :WRITE_LOG ""
call :WRITE_LOG "Haben Sie eine Original-DOS-Sternenschweif-CD und wollen Sie die DAT-Datei darauf automatisch suchen lassen? (J/N)"
set /P NLT_AUTO_DETECT_CONFIRM=
call :WRITE_LOG "Eingabe: %NLT_AUTO_DETECT_CONFIRM%"

if "%NLT_AUTO_DETECT_CONFIRM%" == "j" (
	goto ASK_FOR_CD_DRIVE_LETTER
) else if "%NLT_AUTO_DETECT_CONFIRM%" == "J" (
	goto ASK_FOR_CD_DRIVE_LETTER
) else if "%NLT_AUTO_DETECT_CONFIRM%" == "n" (
	goto TELL_ABOUT_DAT_FILE
) else if "%NLT_AUTO_DETECT_CONFIRM%" == "N" (
	goto TELL_ABOUT_DAT_FILE
) else (
	call :WRITE_LOG "FEHLERHAFTE EINGABE."
	call :WRITE_LOG "Bitte verwenden Sie J oder N"
	goto ASK_FOR_DAT_AUTO_DETECT_CD
)


:ASK_FOR_CD_DRIVE_LETTER
call :WRITE_LOG ""
call :WRITE_LOG ""
call :WRITE_LOG "Bitte DOS-Spiel-CD in Ihr CD/DVD/BD-Laufwerk einlegen."
pause
call :WRITE_LOG ""
call :WRITE_LOG ""
call :WRITE_LOG "Bitte Laufwerkbuchstaben Ihres CD/DVD/BD-Laufwerkes eingeben:"
set /P CD_DRIVE_LETTER=
call :WRITE_LOG "Eingabe: %CD_DRIVE_LETTER%"
echo %CD_DRIVE_LETTER%|findstr : >NUL
if not "%ERRORLEVEL%" == "0" (
set CD_DRIVE_LETTER=%CD_DRIVE_LETTER%:
)
call :WRITE_LOG "Pruefe Laufwerk..."
if not exist %CD_DRIVE_LETTER% (
	call :WRITE_LOG ""
	call :WRITE_LOG ""
	call :WRITE_LOG "FEHLER: CD-Laufwerk konnte nicht gefunden werden."
	goto ASK_FOR_DAT_AUTO_DETECT_CD
) else (
	call :WRITE_LOG "...Laufwerk gefunden."
	goto FIND_DAT_FILE_CD
)


:FIND_DAT_FILE_CD
call :WRITE_LOG "Suche DAT-Datei..."
pushd %CD_DRIVE_LETTER%
for /r %%x in (%NLT2_SOUND_DAT_FILE%) do (
	if exist "%%x" (
		call :WRITE_LOG "...NLT2-DAT-Datei gefunden: %%x."
		call :WRITE_LOG "Kopiere DAT-Datei %%x..."
		xcopy "%%x" "%MODPATH%\supportdata\dat\nlt2\*" /R /Y >>"%LOGFILE%" 2>&1
		if not exist "%MODPATH%\supportdata\dat\nlt2\%NLT2_SOUND_DAT_FILE%" (
			call :WRITE_LOG "FEHLER beim Kopieren der DAT-Datei."
			popd
			goto ERROREXIT
		)
		call :WRITE_LOG "...DAT-Datei kopiert"
		set DAT_FILE=%MODPATH%\supportdata\dat\nlt2\%NLT2_SOUND_DAT_FILE%
		set MAPPING_FILE=%MAPPING_FILE_NLT2%
		set UNPACK_PATH=%MODPATH%\supportdata\unpack\nlt2
		popd
		goto UNPACK_NLT2
	)
)


REM # Schatten ueber Riva: funktioniert noch nicht
REM for /r %%x in (%NLT3_SOUND_DAT_FILE%) do (
REM 	if exist "%%x" (
REM 		call :WRITE_LOG "...NLT3-DAT-Datei gefunden: %%x."
REM 		call :WRITE_LOG "Kopiere DAT-Datei %%x..."
REM 		xcopy "%%x" "%MODPATH%\supportdata\dat\nlt3\*" /K /F /O /X /Y >>"%LOGFILE%" 2>&1
REM			if not exist "%MODPATH%\supportdata\dat\nlt3\%NLT3_SOUND_DAT_FILE%" (
REM				call :WRITE_LOG "FEHLER beim Kopieren der DAT-Datei."
REM				popd
REM				goto ERROREXIT
REM			)
REM 		call :WRITE_LOG "...DAT-Datei kopiert"
REM 		set DAT_FILE=%MODPATH%\supportdata\dat\nlt3\%%x
REM 		set MAPPING_FILE=%MAPPING_FILE_NLT3%
REM 		set UNPACK_PATH=%MODPATH%\supportdata\unpack\nlt3
REM 		popd
REM 		goto UNPACK_NLT3
REM 	)
REM )
popd
call :WRITE_LOG "FEHLER: dat-File konnte nicht gefunden werden."
goto ASK_FOR_DAT_AUTO_DETECT_CD


:TELL_ABOUT_DAT_FILE
call :WRITE_LOG ""
call :WRITE_LOG ""
call :WRITE_LOG "Anleitung fuer Download-Varianten von Sternenschweif (z.B. GOG oder STEAM):"
call :WRITE_LOG "Sie muessen die Sternenschweif-dat-Datei (%NLT2_SOUND_DAT_FILE%) suchen und in folgendem Verzeichnis ablegen:"
call :WRITE_LOG "%MODPATH%\supportdata\dat\nlt2"
pause
call :WRITE_LOG "Pruefe DAT-Datei..."
if exist "%MODPATH%\supportdata\dat\nlt2\%NLT2_SOUND_DAT_FILE%" (
	call :WRITE_LOG "...NLT2-DAT-Datei gefunden."
	set DAT_FILE=%MODPATH%\supportdata\dat\nlt2\%NLT2_SOUND_DAT_FILE%
	set UNPACK_PATH=%MODPATH%\supportdata\unpack\nlt2
	set MAPPING_FILE=%MAPPING_FILE_NLT2%
	goto UNPACK_NLT2
	
	REM # Schatten ueber Riva: funktioniert noch nicht
	REM ) else if exist "%MODPATH%\supportdata\dat\%NLT3_SOUND_DAT_FILE%" (
	REM set DAT_FILE=%MODPATH%\supportdata\dat\%NLT3_SOUND_DAT_FILE%
	REM set UNPACK_PATH=%MODPATH%\supportdata\unpack\nlt3
	REM call :WRITE_LOG "...NLT3-DAT-Datei gefunden."
	REM goto UNPACK_NLT3
	
) else (
	call :WRITE_LOG ""
	call :WRITE_LOG ""
	call :WRITE_LOG "FEHLER: Datei konnte nicht gefunden werden."
	goto TELL_ABOUT_DAT_FILE
)


:UNPACK_NLT2
call :WRITE_LOG "Entpacke NLT2-DAT-Datei..."
pushd "%UNPACK_PATH%"
"%MODPATH%\supportdata\nltpack\nltpack.exe" x "%DAT_FILE%" >>"%LOGFILE%" 2>&1
if not "%ERRORLEVEL%" == "0" (
	call :ASK_FOR_CONTINUE
)
call :WRITE_LOG "...NLT2-DAT-Datei entpackt."
popd
GOTO PROCCESS_FILE_LIST_CONVERT_HUMAN


REM :UNPACK_RIVA
REM # Schatten ueber Riva: funktioniert noch nicht
REM pushd "%UNPACK_PATH%"
REM REM GENEREATE MASTER-FILE (DSA only)
REM call :WRITE_LOG "Generiere NLT3-Katalog-Datei..."
REM "%MODPATH%\supportdata\nltpack\nltpack.exe" m "%DAT_FILE%" >>"%LOGFILE%" 2>&1
REM if not "%ERRORLEVEL%" == "0" (
REM 	call :ASK_FOR_CONTINUE
REM )
REM call :WRITE_LOG "...NLT3-Katalog-Datei generiert."
REM 
REM call :WRITE_LOG "Entpacke NLT3-DAT-Datei..."
REM REM UNPACK NTL-FILE
REM "%MODPATH%\supportdata\nltpack\nltpack.exe" x "%DAT_FILE%" >>"%LOGFILE%" 2>&1
REM if not "%ERRORLEVEL%" == "0" (
REM 	call :ASK_FOR_CONTINUE
REM )
REM call :WRITE_LOG "...NLT3-DAT-Datei entpackt."
REM popd
REM GOTO PROCCESS_FILE_LIST_CONVERT_HUMAN


:PROCCESS_FILE_LIST_CONVERT_HUMAN
set MAPPING_FILE_HUMAN=%MAPPING_FILE%.human
set CONVERT_ERROR_FLAG=
call :WRITE_LOG "Konvertiere menschliche Vertonung (Mapping-File:%MAPPING_FILE_HUMAN%)..."
for /F "usebackq tokens=1,2 delims=;" %%i in ("%MAPPING_FILE_HUMAN%") do (
	set HDFILE=%%i
	set DOSFILE=%%j
	call :WRITE_LOG "Konvertierung: verarbeite Zeile: !HDFILE!;!DOSFILE!"
	REM IGNORE HEADER LINE
	echo "!HDFILE!;!DOSFILE!"|findstr "HD-Pfad" >NUL
	if "!ERRORLEVEL!" == "0" (
		call :WRITE_LOG "Ignoriere File-Header"
	) else (
		if "!HDFILE!" == "-" (
			call :WRITE_LOG "keine Quelldatei definiert - Eintrag wird uebersprungen"
		) else if "!DOSFILE!" == "-" (
				call :WRITE_LOG "keine Zieldatei definiert - Eintrag wird uebersprungen"
		) else (
			set SOURCE_FILE=%UNPACK_PATH%\!DOSFILE!
			if exist "!SOURCE_FILE!" (
				call :CONVERT_FILE "!HDFILE!" "!DOSFILE!"
			) else (
				call :WRITE_LOG "WARNUNG: Quelldatei nicht vorhanden. !SOURCE_FILE!"
				call :WRITE_LOG "WARNUNG: Datei wird uebersprungen."
			)
		)
	)
)	
		
if  "%ELF_SOUND_REPLACE_FLAG%" == "1" (
	goto PROCCESS_FILE_LIST_CONVERT_ELF
) else (
	goto ENDE
)


:PROCCESS_FILE_LIST_CONVERT_ELF
set MAPPING_FILE_ELF=%MAPPING_FILE%.elf
set CONVERT_ERROR_FLAG=
call :WRITE_LOG "Konvertiere elfische Vertonung (Mapping-File:%MAPPING_FILE_ELF%)..."
for /F "usebackq tokens=1,2 delims=;" %%i in ("%MAPPING_FILE_ELF%") do (
	set HDFILE=%%i
	set DOSFILE=%%j
	call :WRITE_LOG "Konvertierung: verarbeite Zeile: !HDFILE!;!DOSFILE!"
	REM IGNORE HEADER LINE
	echo "!HDFILE!;!DOSFILE!"|findstr "HD-Pfad" >NUL
	if "!ERRORLEVEL!" == "0" (
		call :WRITE_LOG "Ignoriere File-Header"
	) else (
		if "!HDFILE!" == "-" (
			call :WRITE_LOG "keine Quelldatei definiert - Eintrag wird uebersprungen"
		) else if "!DOSFILE!" == "-" (
				call :WRITE_LOG "keine Zieldatei definiert - Eintrag wird uebersprungen"
		) else (
			set SOURCE_FILE=%UNPACK_PATH%\!DOSFILE!
			if exist "!SOURCE_FILE!" (
				call :CONVERT_FILE "!HDFILE!" "!DOSFILE!"
			) else (
				call :WRITE_LOG "WARNUNG: Quelldatei nicht vorhanden. !SOURCE_FILE!"
				call :WRITE_LOG "WARNUNG: Datei wird uebersprungen."
			)
		)
	)
)			
goto ENDE


:CONVERT_FILE
set MODFILE=%1
set MODFILE=%MODFILE:"=%
set DOSFILE_TO_CONVERT=%2
set DOSFILE_TO_CONVERT=%DOSFILE_TO_CONVERT:"=%
pushd "%MODPATH%"
echo %DOSFILE_TO_CONVERT%|findstr /I /R voc$ >NUL
if "%ERRORLEVEL%" == "0" (
	call :WRITE_LOG "Konvertiere %UNPACK_PATH%\%DOSFILE_TO_CONVERT% nach %MODPATH%\%MODFILE%..."
	"%MODPATH%\supportdata\sox-14.4.1a-win32\sox.exe" -t voc -c 1 "%UNPACK_PATH%\%DOSFILE_TO_CONVERT%" -t ogg ".\%MODFILE%" >>"%LOGFILE%" 2>&1
	if not "!ERRORLEVEL!" == "0" (
		set CONVERT_ERROR_FLAG=1
		call :WRITE_LOG "FEHLER bei der Konvertierung."
		pause
	)
	goto :eof
)
REM # Schatten ueber Riva: funktioniert noch nicht
REM echo %DOSFILE_TO_CONVERT%|findstr /I /R asf$ >NUL
REM if "%ERRORLEVEL%" == "0" (
REM 	call :WRITE_LOG "Konvertiere %UNPACK_PATH%\%DOSFILE_TO_CONVERT% nach %MODPATH%\%MODFILE%..."
REM 	CONVERTIERUNG-NOCH-UNKLAR "%UNPACK_PATH%\%DOSFILE_TO_CONVERT%" "%MODPATH%\%MODFILE%" >>"%LOGFILE%" 2>&1
REM		if not "!ERRORLEVEL!" == "0" (
REM			set CONVERT_ERROR_FLAG=1
REM			call :WRITE_LOG "FEHLER bei der Konvertierung."
REM			pause
REM		)
REM 	goto :eof
REM )
call :WRITE_LOG "FEHLER: Format wird nicht unterstuetzt."
pause
goto :eof


:WRITE_LOG
set LOG_LINE_TO_WRITE="%1"
set LOG_LINE_TO_WRITE=%LOG_LINE_TO_WRITE:"=%

if "%LOG_LINE_TO_WRITE%" == "" (
	echo.
	goto :eof
)

echo %LOG_LINE_TO_WRITE%
echo "%DATE%_%TIME%: %LOG_LINE_TO_WRITE%" >>"%LOGFILE%"
goto :eof


:ASK_FOR_CONTINUE
set ASK_FOR_CONTINUE_ANSWER=
call :WRITE_LOG ""
call :WRITE_LOG ""
call :WRITE_LOG "Ein Fehler wurde festgestellt."
call :WRITE_LOG "Wollen Sie fortfahren?"
call :WRITE_LOG ""

set /P ASK_FOR_CONTINUE_ANSWER=
call :WRITE_LOG "Eingabe: %ASK_FOR_CONTINUE_ANSWER%"

if "%ASK_FOR_CONTINUE_ANSWER%" == "j" (
	goto :eof
) else if "%ASK_FOR_CONTINUE_ANSWER%" == "J" (
	goto goto :eof
) else if "%ASK_FOR_CONTINUE_ANSWER%" == "n" (
	goto ERROREXIT
) else if "%ASK_FOR_CONTINUE_ANSWER%" == "N" (
	goto ERROREXIT
) else (
	call :WRITE_LOG "FEHLERHAFTE EINGABE."
	call :WRITE_LOG "Bitte verwenden Sie J oder N"
	goto ASK_FOR_CONTINUE
)
goto goto :eof


:ERROREXIT
call :WRITE_LOG ""
call :WRITE_LOG ""
call :WRITE_LOG "FEHLER: Das Programm wird abgebrochen."
call :WRITE_LOG ""
call :WRITE_LOG "-----------------------------------------------------"
call :WRITE_LOG ""
call :WRITE_LOG "Protokolldatei: %LOGFILE%"
call :WRITE_LOG ""
call :WRITE_LOG "-----------------------------------------------------"
pause
exit 1


:ENDE
call :WRITE_LOG ""
call :WRITE_LOG ""
call :WRITE_LOG "-----------------------------------------------------"

if "%CONVERT_ERROR_FLAG%" == "" (
	call :WRITE_LOG ""
	call :WRITE_LOG ""
	if  "%ELF_SOUND_REPLACE_FLAG%" == "1" (
		call :WRITE_LOG "SternHD2DOSSound aktiviert (inklusive elfische Zauber)."
	) else (
		call :WRITE_LOG "SternHD2DOSSound aktiviert (ohne elfische Zauber)."
	)
) else (
	call :WRITE_LOG ""
	call :WRITE_LOG ""
	call :WRITE_LOG "FEHLER bei der Aktivierung von SternHD2DOSSound."
)
call :WRITE_LOG ""
call :WRITE_LOG "Protokolldatei: %LOGFILE%"
call :WRITE_LOG ""
call :WRITE_LOG "-----------------------------------------------------"
call :WRITE_LOG ""
pause
